/**
 * Compute an approximation of pi by rectangle rule
 * Input: the number of sub-intervals of [0-1]
 * 
 * Library to add in compiling: -lm
 */

#include <stdio.h>
#include <math.h>

int  main(int argc, char **argv)
{
    double PI25DGT = 3.141592653589793238462643;
    int    i, nb_rectangles = 200;
    double x, h;
    double sum=0.0, pi=0.0;

    printf("Please input the number of rectangles for [0-1]: ");
    fflush(stdout);
    scanf("%d", &nb_rectangles);
    
    h = 1.0 / nb_rectangles;

    for (i=0; i<nb_rectangles; i++) {
        x = (i+0.5)*h;         
        sum += 4.0 / (1.0 + x*x);
    }
    pi = sum * h; 

    printf("pi is approximately %.16f\n", pi);
    printf("error to PI25DGT is %.16f\n", fabs(pi-PI25DGT));
 
    return 0;
}

